//
// C++ Interface: cavity_search
//
// Description:
//
//
// Author: mirco <Mirco.till@asamnet.de>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef CAVITY_SEARCH_H
#define CAVITY_SEARCH_H
#include "util.h"
//#include "graph.h"
#include "grid.h"

/** A point within the graph serach algorithm

This is just a helper class to make the graph serach easier to read. Stores the corrdinates of one point and the pointers for a doubly linked list.
*/
class point {
  public:
    int x, y, z;
    point *next;
    point *prev;
    point(point *n, point *p): next(n), prev(p) {};
    point(): next(NULL), prev(NULL) {};
};


int search_cav(iGrid &sg, iGrid &cg, int ngraph = 0);
int check_for_clefts_first_solv(iGrid &cavgrid, int cavdim, int nsour);
int check_for_clefts_sphere(iGrid &cavgrid, double min_directions);
void smooth_solvgrid(double *min, double *max, double maxrad, iGrid &solvgrid);
#endif
