#ifndef _NR_COMPLEX_H_
#define _NR_COMPLEX_H_

typedef struct DCOMPLEX {double r,i;} dcomplex;

dcomplex Cadd(dcomplex a, dcomplex b);
dcomplex Csub(dcomplex a, dcomplex b);
dcomplex Cmul(dcomplex a, dcomplex b);
dcomplex Complex(double re, double im);
dcomplex Conjg(dcomplex z);
dcomplex Cdiv(dcomplex a, dcomplex b);
double Cabs(dcomplex z);
dcomplex Csqrt(dcomplex z);
dcomplex RCmul(double x, dcomplex a);
void free_dcomplex_vector(dcomplex *v, long nl, long nh);
dcomplex *dcomplex_vector(long nl, long nh);
dcomplex **dcomplex_matrix(long nrl, long nrh, long ncl, long nch);
void free_dcomplex_matrix(dcomplex **m, long nrl, long nrh, long ncl, long nch);
void Cnormalize(dcomplex *v,int n);

#endif /* _NR_COMPLEX_H_ */
