/* Matthias Ullmann 					*/
/* Berlin, 04.10.1995					*/
/* 							*/
/* Cell base neighbor list for Monte Carlo Simulations 	*/
/* .....................................................*/

/********************************************************/
/* type definitions					*/
#ifndef __nblist__
#define __nblist__


#ifndef ILIST
#define ILIST
struct iList_struct {int number;
	     	     struct iList_struct *next;
	     	     struct iList_struct *prev; 
	    	    };

typedef struct iList_struct iList;

typedef struct {double spacing;
		double inv_spacing;
		int    look;	   /* In how many neightbour cells shell be */
				   /* looked - in relation to cutoff	    */
		int    *imax;	   /* [1..3] */
		int    *imin;	   /* [1..3] */
		iList  ***root;    /* [imax..imin] */
	       }iListGrid;
#endif
/********************************************************/
/* Functions						*/
void iListGrid_info(FILE *fpout, iListGrid *grid);
iList *iList_vector(long nl, long nh);
iList ***iList_3tensor(long nrl, long nrh, long ncl, long nch, long ndl, long ndh);
void free_iList_vector(iList *v, long nl, long nh);
void free_iList_3tensor(iList ***t, long nrl, long nrh, long ncl, 
                        long nch, long ndl, long ndh);
void init_iList_vector(iList *v, int length);
void init_iListGrid(iListGrid *grid);
void add_to_list(iListGrid *grid, iList *list, double *x);
void remove_from_list(iList *list);
void move_in_list(iListGrid *grid, iList *list, double *x);
void move_in_list_test(iListGrid *grid, iList *list, double *x);
void fill_iListGrid(iListGrid *grid, iList *list, double **xyz, int atoms);

#endif  /*__nblist__*/
