/* ...................................................................*/
/*								      */
/* ...................................................................*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mus_atom.h"
#include "mathematik.h"
#include "util_c.h"
#include "nrutil.h"
#include "radius.h"

/*..............................................................*/
void assign_radius(MUS_atom *mus, Rad *rad)
{
int i,j;
int test;

for (j=1; j<=(*mus).number_of_atoms; j++)
    {test=0;
     for (i=1; i<=(*rad).notypes; i++)
         {if (strlen((*rad).name[i])==2)
	     {if (((*mus).atomid[j][1]==(*rad).name[i][0]) && 
                  ((*mus).atomid[j][2]==(*rad).name[i][1]))
	         {test=1;
                  (*mus).radius[j]=(*rad).rad[i];
                  break;
                 }
             }
	  else {if ((*mus).atomid[j][1]==(*rad).name[i][0])
	           {test=1;
                    (*mus).radius[j]=(*rad).rad[i];
                    break;
                   }
	       }
         }
     if (test==0)
        {(*mus).radius[j]=2.0;
         fprint_PQRatom(stderr,mus,j);
         muwarn("Radius is not assigned!");
        }
    }

    
}

/*..............................................................*/
/* Function writes the charges of an PSF-record and the coor-   */
/* dinates of a CRD-record to a MUF-record.                     */
/* The radius is added in an extra procedure.                   */
/* The first SEGID-char is assumed to be the Chain identifier.  */

void charge_vol_assignment(MUS_atom *mus, CRD_atom *crd, PSF_atom *psf)
{
int i;

for (i=1; i<=(*mus).number_of_atoms; i++)
    {(*mus).identifier[i][0]='A';
     (*mus).identifier[i][1]='T';
     (*mus).identifier[i][2]='O';
     (*mus).identifier[i][3]='M';
     (*mus).identifier[i][4]=' ';
     (*mus).identifier[i][5]=' ';
     (*mus).atomno[i]   =(*crd).atomno[i];
     (*mus).atomid[i][0]=(*crd).atomid[i][3];
     (*mus).atomid[i][1]=(*crd).atomid[i][0];
     (*mus).atomid[i][2]=(*crd).atomid[i][1];
     (*mus).atomid[i][3]=(*crd).atomid[i][2];
     (*mus).atomid[i][4]='\0';
     (*mus).alternate[i]=' ';
     (*mus).temperature[i]=(*crd).variable[i];
     (*mus).residue[i][0]=(*crd).residue[i][0];
     (*mus).residue[i][1]=(*crd).residue[i][1];
     (*mus).residue[i][2]=(*crd).residue[i][2];

     (*mus).chain[i]=(*crd).segid[i][0]; 
     /*(*muf).chain=' ';*/
     /* residue number 2 is the sequence counter and so the one I need here */
     (*mus).res_no[i]=(*crd).res_no2[i];
     (*mus).insert[i]=' ';
     (*mus).xyz[i][1]=(*crd).xyz[i][1];
     (*mus).xyz[i][2]=(*crd).xyz[i][2];
     (*mus).xyz[i][3]=(*crd).xyz[i][3];
     (*mus).charge[i]=(*psf).charge[i];
     /* (*mus).radius[i]=atom_radius(psf,i); */
     /* (*mus).E_min[i] =atom_Emin(psf,i);   */
     (*mus).mass[i]  =(*psf).mass[i];
     /*
     (*mus).ion[i]   =assign_ion((*mus).atomid[i], (*mus).residue[i]);
     (*mus).sigma[i] =assign_sigma((*mus).atomid[i], (*mus).ion[i]);
     (*mus).hbond[i] =assign_hbond((*mus).atomid[i], (*mus).residue[i]);
     */
    }
}

/*..............................................................*/
/* Assigning topology and masses                                */ 
/* the treatment of the torsions here is not qiute correct and  */
/* will be corrected in a later subroutine                      */
/*                                                              */
/* This is a very modified version from create-mus              */
/*                                                              */
void psfcrd2mus(MUS_atom *mus, PSF_atom *psf, CRD_atom *crd)
{
    int i;

 (*mus).number_of_atoms   = (*psf).number_of_atoms;
 (*mus).number_of_bonds   = (*psf).number_of_bonds;
 (*mus).number_of_angles  = (*psf).number_of_angles;
 (*mus).number_of_improp  = (*psf).number_of_improp;
 (*mus).number_of_torsions= (*psf).number_of_torsions;
 (*mus).number_of_nbfix   = 0;
 
 MUS_alloc(mus);
 charge_vol_assignment(mus,crd,psf);

 for (i=1; i<=(*psf).number_of_bonds; i++)
     {(*mus).bond[i][1]=(*psf).bond[i][1];
      (*mus).bond[i][2]=(*psf).bond[i][2];
     }
 for (i=1; i<=(*psf).number_of_angles; i++)
     {(*mus).angle[i][1]=(*psf).angle[i][1];
      (*mus).angle[i][2]=(*psf).angle[i][2];
      (*mus).angle[i][3]=(*psf).angle[i][3];
     }
 for (i=1; i<=(*psf).number_of_improp; i++)
     {(*mus).improp[i][1]=(*psf).improp[i][1];
      (*mus).improp[i][2]=(*psf).improp[i][2];
      (*mus).improp[i][3]=(*psf).improp[i][3];
      (*mus).improp[i][4]=(*psf).improp[i][4];
     }
 for (i=1; i<=(*psf).number_of_torsions; i++)
     {(*mus).torsion[i][1]=(*psf).torsion[i][1];
      (*mus).torsion[i][2]=(*psf).torsion[i][2];
      (*mus).torsion[i][3]=(*psf).torsion[i][3];
      (*mus).torsion[i][4]=(*psf).torsion[i][4];
     }
}

/*..............................................................*/
/* proccedure avoids to assign the same chain identifier to two */
/* segments.							*/
/*								*/
void assign_chains(MUS_atom *mus,CRD_atom *crd)
{
int i, chains=1;
char chain='A';

i=1;
(*mus).chain[i]=chain;
for (i=2; i<=(*mus).number_of_atoms; i++)
    {if (0!=strcmp((*crd).segid[i-1],(*crd).segid[i]))
	{chain++; 
	 chains++;
	 (*mus).chain[i]=chain;
	}
     else {(*mus).chain[i]=chain;
	  }
    }
fprintf(stderr,"I have found %d chains\n",chains);
}
/*..............................................................*/
/* procedure reads the radius file                              */
/*                                                              */
void read_RAD(char *filename, Rad *rad)
{
FILE *fp;
char buff[LINELENGTH];
int i=0;

fp=file_open(filename,"r");
while (fgets(buff,LINELENGTH,fp)!=NULL)
      {if (strncmp(buff,"RAD",3)==0) i++;
      }

(*rad).notypes=i;
(*rad).name=charmatrix(1,(*rad).notypes,0,5);
(*rad).rad=dvector(1,(*rad).notypes);

rewind(fp);
i=0;
while (fgets(buff,LINELENGTH,fp)!=NULL)
      {if (strncmp(buff,"RAD",3)==0) 
          {i++;
           sscanf(buff,"%*s %s %lf", (*rad).name[i],
                                    &(*rad).rad[i]);
         }
      }
}
/*..............................................................*/
/* procedure reads the radius file                              */
/*                                                              */
void print_RAD(FILE *fpout, Rad *rad)
{
int i;

for (i=1; i<=(*rad).notypes; i++)
    {fprintf(fpout,"RAD %s %8.3f\n", (*rad).name[i], (*rad).rad[i]);
    }
}
