//
// C++ Interface: energy_calcs
//
// Description:
//
//
// Author: Mirco Till <Mirco.Till@uni-bayreuth.de>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef ENERGY_CALCS_
#define ENERGY_CALCS_
#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include <math.h>
#include "util.h"


struct boltzmann_energies{
       double Z;
       double mean_energy;
       double min_energy, max_energy;
       double entropy;
       boltzmann_energies():Z(0), mean_energy(0), min_energy(0), max_energy(0), entropy(0){};
       friend ostream& operator<<(ostream &output, boltzmann_energies &en);
};

boltzmann_energies get_partition_function(matrix<float> &gint, d4_tensor<float> &ww, vec<int> &max_vec, vec<int> &min_vec, int target, int target_start, int target_stop, double corr_val, boltzmann_energies &result, double histo_step, double disto_min, double histo_max);
boltzmann_energies get_partition_function(matrix<float> &gint, d4_tensor<float> &ww, vec<int> &max_vec, vec<int> &min_vec, boltzmann_energies &result);
void get_entropy(matrix<float> &gint, d4_tensor<float> &ww, vec<int> &max_vec, vec<int> &min_vec, int target, int target_start, int target_stop, boltzmann_energies &result);
boltzmann_energies get_partition_function(matrix<float> &gint, d4_tensor<float> &ww, vec<int> &max_vec, vec<int> &min_vec, int target, int target_start, int target_stop, boltzmann_energies &result);
void get_energy_histo(matrix<float> &gint, d4_tensor<float> &ww, vec<int> &max_vec, vec<int> &min_vec, int target, int target_start, int target_stop, double min, double max, double step, ofstream &output);
int increase_protstate(vec<int> &prot, int nsites, vec<int> &nin, int target, vec<int> &start_vec, int target_start);
int increase_protstate(vec<int> &prot, int nsites, vec<int> &nin, vec<int> &start_vec);







#endif
