//
// C++ Implementation: error_calcs
//
// Description:
//
//
// Author: Mirco <mirco@Mirco-Laptop>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "error_calcs.h"
on_demand_error::on_demand_error():n(0), actual_error(0), value_sum(0), square_sum(0) {}
on_demand_error::on_demand_error(int test):n(0), actual_error(0), value_sum(0), square_sum(0) {}
double on_demand_error::add_value_online(double to_add) {
  n++;
  value_sum += to_add;
  square_sum += (to_add * to_add);
  double nom = (n * square_sum) - (value_sum * value_sum);
  double delim = n * (n-1);
  actual_error = sqrt(nom/delim);
  if (n>1){return actual_error;}
  else{return 0;};
}

void on_demand_error::add_value(double to_add) {
  n++;
  value_sum += to_add;
  square_sum += (to_add * to_add);
  actual_error = 0;
}

void on_demand_error::remove_value(double to_remove) {
  n--;
  value_sum -= to_remove;
  square_sum -= (to_remove * to_remove);
  actual_error = 0;
}
double on_demand_error::calc_error() {
  double nom = (n * square_sum) - (value_sum * value_sum);
  double delim = n * (n-1);
  actual_error = sqrt(nom/delim);
  if (n>1 && nom > 1E-7){return actual_error;}
  else{return 0;};
}

double on_demand_error::calc_average() {
  if (n != 0) {
    return value_sum/n;
  } else {
    return 0;
  }
}