//
// C++ Implementation: file_io
//
// Description:
//
//
// Author: Mirco Till <Mirco.Till@uni-bayreuth.de>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//


#include "file_io.h"



int read_gint(char *filename, vec<string> &resname, matrix<string> &instlabel, matrix<double> &gi) {
  FILE *file;
  char s1[100], s2[100], s3[100], s4[100], s5[100];
  char line[300];
  int i, site, label;
  file = fopen(filename,"r");
  if (!file) {return 0;};

  while (fgets(line,300,file) !=NULL) {
    site = label = 0;
    if (5==sscanf(line, "%s %s %s %s %s", s1, s2, s3, s4, s5) && 0!=strcmp(s1,"#")) {
      for (i=1;i<=resname.get_dim();i++) {
        if (0==strcmp(resname(i).c_str(),s3)) {
          site = i;
          break;
        };
      };

      if (site) {
        if (instlabel.get_spare_dim(site) < atoi(s2)) {cerr << "Instance number larger in gint than in initial for " << resname(site) << endl;exit(0);};
        gi(site,atoi(s2)) = atof(s5);
        instlabel(site,atoi(s2)) = s4;
      };
    };
  };
  fclose(file);
  return 1;
}

int read_gint(char *filename, vec<string> &resname, matrix<string> &instlabel, matrix<float> &gi) {
  FILE *file;
  char s1[100], s2[100], s3[100], s4[100], s5[100];
  char line[300];
  int i, site, label;
  file = fopen(filename,"r");
  if (!file) {return 0;};

  while (fgets(line,300,file) !=NULL) {
    site = label = 0;
    if (5==sscanf(line, "%s %s %s %s %s", s1, s2, s3, s4, s5) && 0!=strcmp(s1,"#")) {
      for (i=1;i<=resname.get_dim();i++) {
        if (0==strcmp(resname(i).c_str(),s3)) {
          site = i;
          break;
        };
      };

      if (site) {
        if (instlabel.get_spare_dim(site) < atoi(s2)) {cerr << "Instance number larger in gint than in initial for " << resname(site) << endl;exit(0);};
        gi(site,atoi(s2)) = atof(s5);
        instlabel(site,atoi(s2)) = s4;
      };
    };
  };
  fclose(file);
  return 1;
}

istream &my_get_line(stringstream &to_fill, istream &file) {
  string line;
  to_fill.seekp(0,ios::beg);
  to_fill.str("");
  to_fill.clear();
  getline(file, line);
  to_fill.str(line);
  return file;
}

int get_nsites_and_names_and_labels_from_gint(char *filename, vec<string> &resname, matrix<string> &labels, char ad_EC_CP) {

  ifstream file(filename);
  string s1, s2, line;
  int s3, s4;
  stringstream line_stream;
  int i, site, nsites;
  vec<int> nin;
  if (!file) {fprintf(stderr, "%s%s\n", "Cann't open ", filename);};
  nsites = 0;
  nin.init_arr(1,1);
  nin(1) = 0;
  if (resname.get_dim() == 0) {
    resname.init_arr(1,1);
  };
  while (getline(file, line)) {
    line_stream.seekp(0,ios::beg);
    line_stream.clear();
    line_stream.str(line);
    s1 = s2 = "";
    s3 = s4 = 0;
    line_stream >>  s3 >> s4 >> s1 >> s2;
    site = 0;
    if (s3 == 0 || s1 == "#") {continue;}
    for (i=1;i<=resname.get_dim();i++) {
      //  cout << "compare: " << resname(i) << " " << s1 << endl;
      if (resname(i) == s1) {
        site = i;
        break;
      };
    };
    //cout << site << " " << s1 << " " << s2 << endl;
    if (site == 0) {
      nsites++;
      if (resname.get_dim() < nsites) {
        resname.add_item();
        nin.add_item();
        nin(nin.get_dim()) = 0;
      };
      resname(nsites) = s1;
      site = nsites;
    };
    nin(site) += 1;
  };
  file.clear();
  file.seekg(0,ios::beg);
  labels.kill_arr();
  labels.init_arr(1,nsites,nin);
  while (getline(file, line)) {
    line_stream.seekp(0,ios::beg);
    line_stream.clear();
    line_stream.str(line);
    line_stream >>  s3 >> s4 >> s1 >> s2;
    site = 0;
    if (s3 == 0 || s1 == "#") {continue;}
    for (i=1;i<=resname.get_dim();i++) {
      //cout << "compare: " << resname(i) << " " << s1 << endl;
      if (resname(i) == s1) {
        site = i;
        break;
      };
    };
    //cout << site << " " << s1 << " " << resname(site) << endl;
    labels(site,s4) = s2;
  };
  /*
  for(i=1;i<=resname.get_dim();i++){
      cout << resname(i) << " ";
      for(int j=1; j<=nin(i); j++){
          cout << nin(i) << " " << labels(i,j) << " ";
      };
      cout << endl;
  };
  */
  return nsites;

}

int get_nsites_and_names_and_labels_from_gint(igzstream &bin_in, vec<string> &names, matrix<string> &labels) {
  int nsites = 0;
  short i,j;
  vec<int> ninst;
  char tmp_char[20];
  bin_in.read(reinterpret_cast<char *>(&nsites),sizeof(nsites));
  //cout << nsites << endl;
  ninst.init_arr(1,nsites);
  ninst.read_binary(bin_in);
  labels.kill_arr();
  labels.init_arr(1,nsites,ninst);
  names.kill_arr();
  names.init_arr(1,nsites);
  //cout << ninst << endl;

  for (i=1; i<= nsites; i++) {
    bin_in.read(tmp_char,sizeof(char) *20);
    names(i) = tmp_char;
    //cout << names(i) << endl;
  };
  for (i=1; i<= nsites; i++) {
    for (j=1; j<=labels.get_spare_dim(i); j++) {
      bin_in.read(tmp_char,sizeof(char) *20);
      labels(i,j) = tmp_char;
      //cout << labels(i,j) << endl;
    };
  };
  return nsites;
}

void read_w(char *filename, vec<string> &resname, matrix<string> &instlabel, d4_tensor<double> &ints) {
  FILE *file;
  char s1[100], s2[100], s3[100], s4[100], s5[100];
  char line[300];
  int i, site1, site2, label1, label2, to_much;
  file = fopen(filename,"r");
  if (!file) {fprintf(stderr, "%s%s\n", "Cann't open ", filename);};
  to_much = 0;
  /*
  for(int h1 = 1; h1<=resname.get_dim(); h1++){
      for(int h2 = 1; h2<=instlabel.get_spare_dim(h1); h2++){
          for(int h3 = 1; h3<=resname.get_dim(); h3++){
              for(int h4 = 1; h4<=instlabel.get_spare_dim(h3); h4++){
                  ints(h1,h2,h3,h4) = 0;
              };

          };
      };
  };
  */
  while (fgets(line,300,file) !=NULL) {
    site1 = label1 = site2 = label2 = 0;
    if (sscanf(line, "%*s %*s %s %s %*s %*s %s %s %s", s1, s2, s3, s4, s5)) {
      /*printf("%s %s %s %s %s\n", s1,s2,s3,s4,s5); */
      for (i=1;i<=resname.get_dim();i++) {
        if (0==strcmp(resname(i).c_str(),s1)) {
          site1 = i;
          break;
        };
      };
      for (i=1;i<=resname.get_dim();i++) {
        if (0==strcmp(resname(i).c_str(),s3)) {
          site2 = i;
          break;
        };
      };
      if (site1 == 0) {
        cerr << "Unknown site in WW file " << s1 << endl;
        continue;
      }
      if (site2 == 0) {
        cerr << "Unknown site in WW file: " << s3 << endl;
        continue;
      }
      for (i=1;i<=instlabel.get_spare_dim(site1);i++) {
        if (instlabel(site1,i).c_str() && 0==strcmp(instlabel(site1,i).c_str(),s2)) {
          label1 = i;
          break;
        };
      };
      for (i=1;i<=instlabel.get_spare_dim(site2);i++) {
        if (instlabel(site2,i).c_str() && 0==strcmp(instlabel(site2,i).c_str(),s4)) {
          label2 = i;
          break;
        };
      };
      if (!label1) {printf("Unknown instance label in W.dat: %s!\n", s2); exit(1);}
      if (!label2) {printf("Unknown instance label in W.dat: %s!\n", s4); exit(1);}
      if (instlabel.get_spare_dim(site1) < label1) {cerr << "Instance number larger in W than in initial for " << resname(site1) << endl;exit(0);};
      if (instlabel.get_spare_dim(site2) < label2) {cerr << "Instance number larger in W than in initial for " << resname(site2) << endl;exit(0);};
      if (site1 && site2 && site1 <= resname.get_dim() && site2 <= resname.get_dim() && label1 && label2) {
        //   cout << site1 << " " << resname(site1) << " " ;
        // cout << site2 << " " << resname(site2) << " " ;
        // cout << label1 << " " << instlabel(site1,label1) << " " ;
        // cout << label2 << " " << instlabel(site2,label2) << endl;
        //cout << site1 << " " << site2 << " " << label1 << " " << label2 << endl;
        ints(site1,label1,site2,label2) = atof(s5);
      };
    };
  };
  fclose(file);
}

void read_w(char *filename, vec<string> &resname, matrix<string> &instlabel, d4_tensor<float> &ints) {
  FILE *file;
  char s1[100], s2[100], s3[100], s4[100], s5[100];
  char line[300];
  int i, site1, site2, label1, label2, to_much;
  file = fopen(filename,"r");
  if (!file) {fprintf(stderr, "%s%s\n", "Cann't open ", filename);};
  to_much = 0;
  /*
  for(int h1 = 1; h1<=resname.get_dim(); h1++){
  for(int h2 = 1; h2<=instlabel.get_spare_dim(h1); h2++){
  for(int h3 = 1; h3<=resname.get_dim(); h3++){
  for(int h4 = 1; h4<=instlabel.get_spare_dim(h3); h4++){
  ints(h1,h2,h3,h4) = 0;
  };

  };
  };
  };
  */
  while (fgets(line,300,file) !=NULL) {
    site1 = label1 = site2 = label2 = 0;
    if (sscanf(line, "%*s %*s %s %s %*s %*s %s %s %s", s1, s2, s3, s4, s5)) {
      /*printf("%s %s %s %s %s\n", s1,s2,s3,s4,s5); */
      for (i=1;i<=resname.get_dim();i++) {
        if (0==strcmp(resname(i).c_str(),s1)) {
          site1 = i;
          break;
        };
      };
      for (i=1;i<=resname.get_dim();i++) {
        if (0==strcmp(resname(i).c_str(),s3)) {
          site2 = i;
          break;
        };
      };
      if (site1 == 0) {
        cerr << "Unknown site in WW file " << s1 << endl;
        continue;
      }
      if (site2 == 0) {
        cerr << "Unknown site in WW file: " << s3 << endl;
        continue;
      }
      for (i=1;i<=instlabel.get_spare_dim(site1);i++) {
        if (instlabel(site1,i).c_str() && 0==strcmp(instlabel(site1,i).c_str(),s2)) {
          label1 = i;
          break;
        };
      };
      for (i=1;i<=instlabel.get_spare_dim(site2);i++) {
        if (instlabel(site2,i).c_str() && 0==strcmp(instlabel(site2,i).c_str(),s4)) {
          label2 = i;
          break;
        };
      };
      if (!label1) {printf("Unknown instance label in W.dat: %s!\n", s2); exit(1);}
      if (!label2) {printf("Unknown instance label in W.dat: %s!\n", s4); exit(1);}
      if (instlabel.get_spare_dim(site1) < label1) {cerr << "Instance number larger in W than in initial for " << resname(site1) << endl;exit(0);};
      if (instlabel.get_spare_dim(site2) < label2) {cerr << "Instance number larger in W than in initial for " << resname(site2) << endl;exit(0);};
      if (site1 && site2 && site1 <= resname.get_dim() && site2 <= resname.get_dim() && label1 && label2) {
        //   cout << site1 << " " << resname(site1) << " " ;
        // cout << site2 << " " << resname(site2) << " " ;
        // cout << label1 << " " << instlabel(site1,label1) << " " ;
        // cout << label2 << " " << instlabel(site2,label2) << endl;
        //cout << site1 << " " << site2 << " " << label1 << " " << label2 << endl;
        ints(site1,label1,site2,label2) = atof(s5);
      };
    };
  };
  fclose(file);
}



void atom::set_atom(int n, int k, float r, float c, float x1, float y1, float z1, string &set_name, string &rname, int rnum) {
  x = x1;
  y = y1;
  z = z1;
  radius = r;
  charge = c;
  number = n;
  resnum = rnum;
  kind = k;
  is_bb = 0;
  name = set_name;
  resname = rname;
}


atom::atom(const atom &tmp_at) {
  this->x = tmp_at.x;
  this->y = tmp_at.y;
  this->z = tmp_at.z;
  this->radius = tmp_at.radius;
  this->number = tmp_at.number;
  this->kind = tmp_at.kind;
  this->name =  tmp_at.name;

}

void instance::set_inst(const string &set_label, const int site, const int n, const int natom) {
  label = set_label;
  number = n;
  isprot = 0;
  isel = 0;
  atoms.init_arr(1,natom);
  pot = 0;
}

instance::instance(const instance &tmp_inst) {
  int dim;
  this->label = tmp_inst.label;
  this->number = tmp_inst.number;
  this->isprot = tmp_inst.isprot;
  this->isel = tmp_inst.isel;
  this->pot = tmp_inst.pot;
  dim = tmp_inst.atoms.get_dim();
  this->atoms.init_arr(1,dim);
  for (int i = 1; i<=tmp_inst.atoms.get_dim(); i++) {
    this->atoms(i) = tmp_inst.atoms(i);
  };
}

void residue::set_res(const string &na, const int num, const int nins, const int nat, const int ndon, const int naccept) {
  number = num;
  ninst = nins;
  natoms = nat;
  ndonor = ndon;
  nacceptor = naccept;
  is_in_sites = 0;
  pot = 0;
  is_tit = 0;
  name = na;
  atoms.init_arr(1,natoms);
  inst.init_arr(1,nins);
  con.init_arr(0,0);
  con(0) = 0;    // con(0) holds the number of connetions
  inst(1).set_inst(na, number, 1, nat);
}

residue& residue::operator= (const residue& tmp_res) {
  this->pot = 0;
  this->set_res(tmp_res.name, tmp_res.number, tmp_res.ninst, tmp_res.natoms, tmp_res.ndonor, tmp_res.nacceptor);
  for (int i=1; i<=this->natoms; i++) {
    this->atoms(i) = tmp_res.atoms(i);
  };
  return *this;
}

residue::residue(residue& tmp_res) {
  this->pot = 0;
  this->set_res(tmp_res.name, tmp_res.number, tmp_res.ninst, tmp_res.natoms, tmp_res.ndonor, tmp_res.nacceptor);
  for (int i=1; i<=this->natoms; i++) {
    this->atoms(i) = tmp_res.atoms(i);
  };
}

int residue::delete_atom(int num) {
  int counter;
  vec<atom> tmp_at_vec;
  tmp_at_vec.init_arr(1,natoms-1);
  counter = 1;
  for (int i=1; i<=natoms; i++) {
    if (i!=num) {
      tmp_at_vec(counter) = atoms(i);
      counter++;
    };
  };
  atoms.kill_arr();
  atoms.init_arr(1,natoms-1);
  for (int i=1; i<=natoms -1; i++) {
    atoms(i) = tmp_at_vec(i);
  };
  natoms--;
  return 1;

}
prot::prot(char *filename, don_acc_list & don_acc) {
  string finame = filename;
  int tmp_int = finame.find(".pqr");
  name.assign(finame,0,tmp_int);
  string siterep_name;
  siterep_name = name + ".siterep";
  ifstream pqr(finame.c_str());
  ifstream srfile(siterep_name.c_str());
  siterep_site *sr_site;
  int natom, prev, atom_count;
  string tmp, st1, atom, resn;
  int atomnum, resnum;
  float x,y,z, rad, charge;
  stringstream line;
  natom = nres = prev = atom_count = 0;
  // first pof all, lets get the siterep
  sr_site = NULL;
  siterep sr(srfile);
  //cout << sr;
  srfile.clear();
  srfile.seekg(0,ios::beg);
  while (my_get_line(line,pqr)) {
    line >> st1;
    if (st1 == "ATOM") {
      line >> atomnum >> atom >> resn >> resnum >> x >> y >> z;
      //cout << atomnum << " " << atom << " " << resn << " " << resnum << " " << x << " " << y << " " << z << endl;
      if (prev != resnum) {
        nres++;
        prev = resnum;
      };
    };
  };
  nres = nres+2;
  res.init_arr(1,nres);

  pqr.clear();
  pqr.seekg(0,ios::beg);
  pqr.clear();
  nres = prev = 0;
  while (my_get_line(line,pqr)) {
    line >> st1;
    if (st1 == "ATOM") {
      x = y = z = rad = charge = 0;
      line >> atomnum >> atom >> resn >> resnum >> x >> y >> z >> charge >> rad;
      //cout << atomnum << " " << atom << " " << resn << " " << resnum << " " << x << " " << y << " " << z << endl;
      if (prev != resnum) {
        if (nres != 0) {
          // add instances for the last residue
          add_instances(sr, res(nres));
        };
        nres++;
        prev = resnum;
        atom_count = 0;
        if (nres > res.get_dim()) {
          res.add_item();
        };
        sr_site = NULL;
        for (int i=1; i<=sr.sites.get_dim(); i++) {
          if (sr.sites(i).name == resn) {
            sr_site = & (sr.sites(i));
          };
        };
        if (sr_site != NULL) {
          res(nres).set_res(resn, resnum, (*sr_site).ninst, 1, 0, 0);
        } else {
          res(nres).set_res(resn, resnum, 1, 1, 0, 0);
        };
      }
      atom_count++;
      if (atom_count > res(nres).atoms.get_dim()) {      // If there are more atoms we need memory for that
        res(nres).natoms = atom_count;
        res(nres).inst(1).atoms.add_item();
        res(nres).atoms.add_item();
      };
      res(nres).inst(1).atoms(atom_count).set_atom(atomnum, 0, rad, charge, x, y, z, atom, resn, resnum);             // This atom belongs to the first instance
      res(nres).atoms(atom_count).set_atom(atomnum, 0, rad, charge, x, y, z, atom, resn, resnum);          // And is also the general state, if ther are no instances
      if (sr_site != NULL) {
        for (int at2 = 1; at2 <= (*sr_site).nheavy; at2++) {
          if (res(nres).atoms(atom_count).name == (*sr_site).heavy(at2)) {
            res(nres).atoms(atom_count).is_heavy = 1;
            break;
          };
        };
      };

    }
  }

  // add instacnes for the last residue
  add_instances(sr, res(nres));
  cout << "Sites found in " << name << ": " << nres << endl;
  //finally add EC an CP
  tmp = "EC";
  res(nres+1).set_res(tmp, nres+1,1, 1, 0, 0);
  //res(nres+1).atoms(1).set_atom(1,1,1.0,1.0,1.0,s1);
  //res(nres+1).inst(1).set_inst(s1,1,1,1.0,1);
  tmp = "CP";
  res(nres+2).set_res(tmp,nres+2,1,1,0,0);
  //res(nres+2).atoms(1).set_atom(1,1,1.0,1.0,1.0,s1);
  //res(nres+2).inst(1).set_inst(s1,1,1,1.0,1);
  nres += 2;
  tmp = name + ".sites";

  // Set backbone heavy atoms for all instances
  for (int site1 = 1; site1 <=nres; site1++) {
    for (int inst1=1; inst1 <= res(site1).ninst; inst1++) {
      for (int at1=1; at1<=res(site1).natoms; at1++) {
        for (int i = 1; i<=don_acc.ndonor;i++) {
          if (0 == strcmp(res(site1).inst(inst1).atoms(at1).name.c_str(),don_acc.donor(i))) {
            if (res(site1).inst(inst1).atoms(at1).kind == 0) {            // only set this kind, if its not overwritten anywhere else
              res(site1).inst(inst1).atoms(at1).kind = 1;
            };
            res(site1).atoms(at1).kind = 1;
          };
        };
        for (int i = 1; i<=don_acc.nacceptor;i++) {
          if (0 == strcmp(res(site1).inst(inst1).atoms(at1).name.c_str(),don_acc.acc(i))) {
            if (res(site1).inst(inst1).atoms(at1).kind == 0) {            // only set this kind, if its not overwritten anywhere else
              res(site1).inst(inst1).atoms(at1).kind = -1;
            };
            // If the bb heavy atom is already set as heavy atom in the siterep file, dont set it as bb
            if (!res(site1).atoms(at1).is_heavy) {
              res(site1).atoms(at1).is_bb = 1;
            };
            res(site1).atoms(at1).kind = -1;
            res(site1).atoms(at1).is_heavy = 1;
          }
        };
        for (int i = 1; i<=don_acc.nlp;i++) {
          if (0 == strcmp(res(site1).inst(inst1).atoms(at1).name.c_str(),don_acc.lp(i))) {
            if (res(site1).inst(inst1).atoms(at1).kind == 0) {            // only set this kind, if its not overwritten anywhere else
              res(site1).inst(inst1).atoms(at1).kind = -2;
            };
            res(site1).atoms(at1).kind = -1;
          }
        };
      };
    };
  };
  read_sites(tmp.c_str(), tit_res, this);

}

prot::prot(char *filename) {
  string finame = filename;
  int tmp_int = finame.find(".pqr");
  name.assign(finame,0,tmp_int);
  string siterep_name;
  siterep_name = name + ".siterep";
  ifstream pqr(finame.c_str());
  ifstream srfile(siterep_name.c_str());
  siterep_site *sr_site;
  int natom, prev, atom_count;
  string tmp, st1, atom, resn;
  int atomnum, resnum;
  float x,y,z, rad, charge;
  stringstream line;
  natom = nres = prev = atom_count = 0;
  // first pof all, lets get the siterep
  sr_site = NULL;
  siterep sr(srfile);
  //cout << sr;
  srfile.clear();
  srfile.seekg(0,ios::beg);
  while (my_get_line(line,pqr)) {
    line >> st1;
    if (st1 == "ATOM") {
      line >> atomnum >> atom >> resn >> resnum >> x >> y >> z;
      //cout << atomnum << " " << atom << " " << resn << " " << resnum << " " << x << " " << y << " " << z << endl;
      if (prev != resnum) {
        nres++;
        prev = resnum;
      };
    };
  };
  nres = nres+2;
  res.init_arr(1,nres);

  pqr.clear();
  pqr.seekg(0,ios::beg);
  pqr.clear();
  nres = prev = 0;
  while (my_get_line(line,pqr)) {
    line >> st1;
    if (st1 == "ATOM") {
      x = y = z = rad = charge = 0;
      line >> atomnum >> atom >> resn >> resnum >> x >> y >> z >> charge >> rad;
      //cout << atomnum << " " << atom << " " << resn << " " << resnum << " " << x << " " << y << " " << z << endl;
      if (prev != resnum) {
        if (nres != 0) {
          // add instances for the last residue
          add_instances(sr, res(nres));
        };
        nres++;
        prev = resnum;
        atom_count = 0;
        if (nres > res.get_dim()) {
          res.add_item();
        };
        sr_site = NULL;
        for (int i=1; i<=sr.sites.get_dim(); i++) {
          if (sr.sites(i).name == resn) {
            sr_site = & (sr.sites(i));
          };
        };
        if (sr_site != NULL) {
          res(nres).set_res(resn, resnum, (*sr_site).ninst, 1, 0, 0);
        } else {
          res(nres).set_res(resn, resnum, 1, 1, 0, 0);
        };
      }
      atom_count++;
      if (atom_count > res(nres).atoms.get_dim()) {      // If there are more atoms we need memory for that
        res(nres).natoms = atom_count;
        res(nres).inst(1).atoms.add_item();
        res(nres).atoms.add_item();
      };
      res(nres).inst(1).atoms(atom_count).set_atom(atomnum, 0, rad, charge, x, y, z, atom, resn, resnum);             // This atom belongs to the first instance
      res(nres).atoms(atom_count).set_atom(atomnum, 0, rad, charge, x, y, z, atom, resn, resnum);          // And is also the general state, if ther are no instances
      if (sr_site != NULL) {
        for (int at2 = 1; at2 <= (*sr_site).nheavy; at2++) {
          if (res(nres).atoms(atom_count).name == (*sr_site).heavy(at2)) {
            res(nres).atoms(atom_count).is_heavy = 1;
            break;
          };
        };
      };

    }
  }

  // add instacnes for the last residue
  add_instances(sr, res(nres));
  //cout << "Sites found in " << name << ": " << nres << endl;
  //finally add EC an CP
  tmp = "EC";
  res(nres+1).set_res(tmp, nres+1,1, 1, 0, 0);
  //res(nres+1).atoms(1).set_atom(1,1,1.0,1.0,1.0,s1);
  //res(nres+1).inst(1).set_inst(s1,1,1,1.0,1);
  tmp = "CP";
  res(nres+2).set_res(tmp,nres+2,1,1,0,0);
  //res(nres+2).atoms(1).set_atom(1,1,1.0,1.0,1.0,s1);
  //res(nres+2).inst(1).set_inst(s1,1,1,1.0,1);
  nres += 2;
  tmp = name + ".sites";
  read_sites(tmp.c_str(), tit_res, this);

}

prot::prot(const prot &tmp_prot) {
  this->nres = tmp_prot.nres;
  this->set_prot(this->nres);
  this->name = tmp_prot.name;
  for (int residue=1;residue <= this->nres; residue++) {
    this->res(residue).set_res(tmp_prot.res(residue).name, tmp_prot.res(residue).number, tmp_prot.res(residue).ninst, tmp_prot.res(residue).natoms, tmp_prot.res(residue).ndonor, tmp_prot.res(residue).nacceptor);
    for (int at=1; at <= res(residue).natoms; at++) {
      res(residue).atoms(at) = tmp_prot.res(residue).atoms(at);
    };
  };
}

void prot::print_as_pdb(ostream& outp) {

  outp.setf(ios::fixed, ios::floatfield);
  outp.setf(ios::showpoint);
  outp.precision(3);
  for (int residue=1; residue <= nres - 2; residue++) {    //-2 since we have no coors for EC and CP
    for (int at=1; at <= res(residue).natoms; at++) {
      outp.width(-5);
      outp << "ATOM";
      outp.width(7);
      outp << res(residue).atoms(at).number;
      outp.width(4);
      outp << res(residue).atoms(at).name;
      outp.width(5);
      outp << res(residue).name;
      outp.width(6);
      outp << res(residue).number;
      outp.width(12);
      outp << res(residue).atoms(at).x;
      outp.width(8);
      outp << res(residue).atoms(at).y;
      outp.width(8);
      outp << res(residue).atoms(at).z;
      outp.width(6);
      outp << 0.000;
      outp.width(6);
      outp << 0.000;

      outp << endl;
    };
  };
}

don_acc_list::don_acc_list(char *filename) {
  ifstream file(filename);
  if (!file) {cerr << "Can't open don_acc.dat" << endl; exit(0);};
  char s1[100], s2[100],buf[300];
  ndonor = nacceptor = nlp = 0;
  while (file.getline(buf,300)) {
    if (2==sscanf(buf,"%s %s", s1, s2)) {
      if (0 == strcmp(s1,"Don")) {
        ndonor++;
      } else if (0 == strcmp(s1,"Acc")) {
        nacceptor++;
      } else if (0 == strcmp(s1, "LP")) {
        nlp++;
      };
    }
  };
  file.clear();
  file.seekg(0, ios::beg);
  donor.init_arr(1,ndonor,0,10);
  acc.init_arr(1,nacceptor,0,10);
  lp.init_arr(1,nlp,0,10);
  ndonor = nacceptor = nlp = 0;
  while (file.getline(buf,300)) {
    if (2==sscanf(buf,"%s %s", s1, s2)) {
      if (0 == strcmp(s1,"Don")) {
        ndonor++;
        strcpy(donor(ndonor), s2);
      } else if (0 == strcmp(s1,"Acc")) {
        nacceptor++;
        strcpy(acc(nacceptor), s2);
      } else if (0 == strcmp(s1, "LP")) {
        nlp++;
        strcpy(lp(nlp), s2);
      };
    }
  };
}

int get_ninst(char *resname, const char *molname) {
  char filename[100];
  sprintf(filename, "%s%s", molname, ".siterep");
  ifstream file(filename);
  if (!file) {
    // cerr << "No instance file for " << filename << endl;
    return 0;
  };
  string local_name, s1, s2, line;
  int flag = 0;
  while (file) {
    if (flag == 0) {file >> s1;}
    if (s1 == "site") {
      flag = 0;
      file >> s2;
      local_name = s2;
      while (flag == 0 && file) {
        file >> s1;
        if (s1 == "ninst") {
          file >> s2;
          if (strcmp(local_name.c_str(),resname) ==0) {
            return atoi(s2.c_str());
          };
          getline(file,line);
        } else if (s1 == "site") {
          flag = 1;
        } else{getline(file,line);}
      };
    };
  };
  return 1;
}

int add_instances(siterep &sr, residue &res) {
  //cout << "Add instances for " << res.name << res.number << endl;
  int flag = 0;
  string local_name, s1, s2, s3, line, tmp;
  for (int i=1; i<= sr.titsites; i++) {
    if (res.name == sr.sites(i).name) {
      res.max_nprot = sr.sites(i).max_nprot;
      res.min_nprot = sr.sites(i).min_nprot;
      res.is_tit = 1;
      for (int n = 2; n <= sr.sites(i).ninst; n++) {
        res.inst(n).set_inst(sr.sites(i).labels(n), res.number, n, res.natoms);
        for (int atn = 1; atn <= res.natoms; atn++) {
          res.inst(n).atoms(atn) = res.atoms(atn);
          res.inst(n).atoms(atn).kind = 0;
        };
      };
      for (int nis = 1; nis <= sr.sites(i).ninst; nis++) {
        res.inst(nis).label = sr.sites(i).labels(nis);
        res.inst(nis).isprot = sr.sites(i).prot(nis);
        res.inst(nis).isel = sr.sites(i).el(nis);
        for (int at = 1; at <= res.natoms; at++) {
          flag = 1;
          //for(int at2 = 1; at2 <= res.natoms; at2++){
          for (int at2 = 1; at2 <= sr.sites(i).ndon(nis); at2++) {
            if (res.inst(nis).atoms(at).name == sr.sites(i).don(nis,at2)) {
              res.inst(nis).atoms(at).kind = 1;
              flag = 0;
              break;
            };
          };

          if (flag) {
            for (int at2 = 1; at2 <= sr.sites(i).nacc(nis); at2++) {
              if (res.inst(nis).atoms(at).name == sr.sites(i).acc(nis,at2)) {
                res.inst(nis).atoms(at).kind = -1;
                flag = 1;
                break;
              };
            };
          };
          if (flag) {
            for (int at2 = 1; at2 <= sr.sites(i).nlp(nis); at2++) {
              if (res.inst(nis).atoms(at).name == sr.sites(i).lp(nis,at2)) {
                res.inst(nis).atoms(at).kind = -2;
                break;
              };
            };
          };

        };
      };
    };
  };
  /*
  for(int nis = 1; nis <= res.ninst; nis++){
      for(int at = 1; at <= res.natoms; at++){
          cout << "site: " << res.name
                  << " instance: " << nis << " " << res.inst(nis).label
                  << " atoms: " << res.inst(nis).atoms(at).name
                  << " kind: " << res.inst(nis).atoms(at).kind << endl;
      };
  };
  cout << endl << endl;
  */
  return 1;
}

int read_connect(char *filename, prot &ga) {

  ifstream file(filename);
  if (!file) {
    // cerr << "No instance file for " << filename << endl;
    return 1;
  }
  string buf, name1, name2, unused1, unused2;
  char new_name[100], new_name2[100], new_name3[100];
  int res1, res2, ncon, flag;
  while (file) {
    name1 = name2 = "0";
    file >> name1 >> name2 >> unused1 >> unused2;

    if (name1 != "0") {
      res1 = res2 = 0;
      for (int i = 1; i<=ga.nres; i++) {
        sprintf(new_name,"%s-%d", ga.res(i).name.c_str(), ga.res(i).number);
        sprintf(new_name2,"%s%d-0", ga.res(i).name.c_str(), ga.res(i).number);
        sprintf(new_name3,"%s", ga.res(i).name.c_str());
        if (strcmp(name1.c_str(),new_name)==0 || strcmp(name1.c_str(),new_name2)==0 || strcmp(name1.c_str(),new_name3)==0) {
          res1 = i;
        };
        if (strcmp(name2.c_str(),new_name)==0 || strcmp(name2.c_str(),new_name2)==0 || strcmp(name2.c_str(),new_name3)==0) {
          res2 = i;
        };
        if(res1 && res2){break;};
      };
      if (res1 && res2) {
        flag = 1;
        // We only add the connections which are not already present or added from other routines
        for (int i=1; i<=ga.res(res1).con(0); i++) {
          if (ga.res(res1).con(i) == res2) {
            flag = 0;
            break;
          };
        };
        if (flag) {
          ncon = ga.res(res1).con(0);
          ga.res(res1).con.add_item();
          ga.res(res1).con(ncon + 1) = res2;
          ga.res(res1).con(0) = ncon + 1;
          ncon = ga.res(res2).con(0);
          ga.res(res2).con.add_item();
          ga.res(res2).con(ncon + 1) = res1;
          ga.res(res2).con(0) = ncon + 1;
        };
      } else if (!res1) {
        cerr << "Unknown res in connect: " << name1 << endl;
        exit(1);
      } else if (!res2) {
        cerr << "Unknown res in connect: " << name2 << endl;
        exit(1);
      };
    };
  };
  return 0;
}


void read_sites(const char *filename, vec<string> &tit_sites, prot *whole_prot) {
  cout.setf(ios::uppercase | ios::scientific);
  cout.precision(4);
  ifstream file(filename);
  char tmp_name[30];

  if (!file) {
    cerr << "No sites file:  " << filename << endl;
    cerr << "Setting all sites like beeing in sites file!" << endl;
    for (int k=1; k<= (*whole_prot).nres; k++) {
      (*whole_prot).res(k).is_in_sites = 1;
    };
    return;
  }
  string name1, name2;
  char new_name[100];
  int nsites;
  nsites = 0;
  while (file) {
    file >> name1 >> name2;
    if (name1 == "!") {file.getline(new_name,100);}
    else {
      nsites++;
    }
  };
  file.clear();
  file.seekg(0, ios::beg);
  tit_sites.init_arr(1,nsites);
  nsites = 0;
  while (file) {
    file >> name1 >> name2;
    if (name1 == "!") {file.getline(new_name,100);}
    else {
      nsites++;
      tit_sites(nsites) = name2+name1;
      for (int k=1; k<= (*whole_prot).nres; k++) {
        sprintf(tmp_name,"%s%d", (*whole_prot).res(k).name.c_str(), (*whole_prot).res(k).number);
        if (0==strcmp(tmp_name,tit_sites(nsites).c_str())) {
          (*whole_prot).res(k).is_in_sites = 1;
          // cout << (*whole_prot).res(k).name << " " << (*whole_prot).res(k).number << " is in sites\n";
        }
      }
    };
  };
}

void read_rotations(char *filename, prot &prot) {
  ifstream file(filename);
  string tmp_assign, buff, s1, tmp_assign2;
  char tmp_name[100];
  int tmp_nrots, max_nrots, seeker, flag;
  max_nrots = 0;
  while (file) {
    tmp_nrots = 0;
    flag = 0;
    file >> s1;
    getline(file, buff, '\n');
    tmp_assign = buff;
    for (int i=1; i<=prot.nres; i++) {
      sprintf(tmp_name, "%s%d-0", prot.res(i).name.c_str(), prot.res(i).number);
      if (s1 == tmp_name) {
        flag = 1;
        prot.res(i).nrotation_groups++;
        break;
      };
    };
    while (tmp_assign.size() > 2) {
      seeker = tmp_assign.find(" ");
      tmp_nrots++;
      tmp_assign = tmp_assign.assign(tmp_assign,seeker+2,tmp_assign.size());
    };
    if (flag) {

      if (max_nrots < tmp_nrots) {max_nrots = tmp_nrots;}
    };
  };
  for (int i=1; i<=prot.nres; i++) {
    if (prot.res(i).nrotation_groups) {
      prot.res(i).rotations.init_arr(1,prot.res(i).nrotation_groups,0,max_nrots);
      prot.res(i).nrotation_groups = 0;
    };
  };
  file.clear();
  file.seekg(0, ios::beg);
  while (file) {
    tmp_nrots = 0;
    flag = 0;
    file >> s1;
    getline(file, buff, '\n');
    tmp_assign = buff;
    for (int i=1; i<=prot.nres; i++) {
      sprintf(tmp_name, "%s%d-0", prot.res(i).name.c_str(), prot.res(i).number);
      if (s1 == tmp_name) {
        flag = i;
        prot.res(i).nrotation_groups++;
        break;
      };
    };
    while (tmp_assign.size() > 2) {
      seeker = tmp_assign.find(" ");
      tmp_nrots++;
      tmp_assign2.assign(tmp_assign,seeker,seeker + 3);
      prot.res(flag).rotations(prot.res(flag).nrotation_groups,tmp_nrots) = atoi(tmp_assign2.c_str());
      tmp_assign = tmp_assign.assign(tmp_assign,seeker+2,tmp_assign.size());
    };
    prot.res(flag).rotations(prot.res(flag).nrotation_groups,0) = tmp_nrots;
  };
}

siterep_site::siterep_site() : ninst(0), nheavy(0), max_nprot(0), max_nel(0) {


}
siterep::siterep(ifstream &file) :titsites(0), max_n_prot(0), max_n_el(0) {
  // Changed to instance labels for making the whole thing more general!
  if (!file) {cerr << "can't read siterep file";}
  int nsites = 0, nat = 0, max_nat = 0, max_nprot, min_nprot, max_nel, atom_num = 0, nh = 0;
  string site_local, s1, s2, s3, inst_label;
  int i1, i2,i3, inst_num;
  stringstream line;
  s1 = "";
  while (my_get_line(line,file)) {
    // find first occurence of "site" in file
    line >> s1;
    if (s1 == "site") {
      break;
    };
  };
  while (file) {
    line >> site_local;
    nsites++;
    nh = 0;
    while (my_get_line(line,file)) {
      line >> s1;
      if (s1 == "instdon" || s1 == "instacc" || s1 == "instlp" || s1 == "atoms") {
        nat = 0;
        while (line) {
          line >> s2;
          nat++;
        };
        if (max_nat < nat) {max_nat = nat;};

      };
      if(s1 == "heavy"){nh++;}
      if(nh > max_nat){max_nat = nh;}
      if (s1 == "site") {
        break;
      };
    }
  }
  sites.init_arr(1,nsites);
  file.clear();
  file.seekg(0, ios::beg);
  titsites = nsites;
  nsites = 0;
  max_nprot = 0;
  min_nprot = 100;
  while (my_get_line(line,file)) {
    // find first occurence of "site" in file
    line >> s1;
    if (s1 == "site") {
      break;
    };
  };
  while (file) {
    line >> site_local;
    // cout << endl << endl << site_local << endl;
    nsites++;
    sites(nsites).name = site_local;
    max_nprot = -100;
    min_nprot = 100;
    max_nel = 0;
    inst_num = 0;
    while (my_get_line(line,file)) {
      line >> s1;
      //cout << s1 << " ";
      if (s1 == "ninst") {
        line >> i1;
        // cout << i1 << endl;
        sites(nsites).set_site(i1, max_nat);
      } else if (s1 == "atoms") {
        atom_num = 0;
        while (line) {
          s2 = "";
          line >> s2;
          if (s2 != "") {
            atom_num++;
            sites(nsites).atoms(atom_num) = s2;
          }
        }
        sites(nsites).natoms = atom_num;
        // set all atoms the same
        for (int k=1; k<= atom_num; k++) {
          for (int k2=1; k2<=sites(nsites).ninst; k2++) {
            sites(nsites).atom_change(k2,k) = sites(nsites).atoms(k);
          }
        }
        //cout << nsites << " with atoms " << sites(nsites).natoms << endl;
      } else if (s1 == "atomchange") {
        if (inst_num == 0) {cerr << "inst flag has to be at least one line before atomchange" << endl;}
        if (sites(nsites).natoms == 0) {cerr << "atoms flag has to be at least one line before atomchange" << endl;}
        while (line) {
          line >> s2 >> s3;
          if (s2 != "") {
            for (int k=1; k<=sites(nsites).natoms; k++) {
              if (sites(nsites).atoms(k) == s2) {
                sites(nsites).atom_change(inst_num,k) = s3;
                break;
              }
            }
          }
        }
        sites(nsites).natoms = atom_num;
      } else if (s1 == "heavy") {
        line >> s2;
        //cout << s2 << endl;
        sites(nsites).nheavy = sites(nsites).nheavy + 1;
        sites(nsites).heavy(sites(nsites).nheavy) = s2;
      } else if (s1 == "inst") {
        line >> inst_label >> i2 >> i3;
        //cout << i1 << " " << i2 << " " << i3 << endl;
        inst_num = sites(nsites).find_inst_num(inst_label);
        sites(nsites).prot(inst_num) = i2;
        sites(nsites).labels(inst_num) = inst_label;
        sites(nsites).el(inst_num) = i3;
        if (i2 >= max_nprot) {max_nprot = i2;}
        if (i2 <= min_nprot) {min_nprot = i2;}
        if (i3 >= max_nel) {max_nel = i3;}
      } else if (s1 == "instacc") {
        // Guard
        if (inst_num == 0) {cerr << "Instance number not found. Check if you have a inst statement before this line! " << endl;}
        //cout << i1 << " ";
        int n = 1;
        while (line) {
          s1 = "";
          line >> s1;
          //cout << s1 << " ";
          if (s1 != "") {
            n++;
            sites(nsites).acc(inst_num,n) = s1;
            sites(nsites).nacc(inst_num) = n;
          };
        };
        // cout << endl;
      } else if (s1 == "instdon") {
        //cout << i1 << " ";
        // Guard
        if (inst_num == 0) {cerr << "Instance number not found. Check if you have a inst statement before this line! " << endl;}
        int n = 0;
        while (line) {
          s1 = "";
          line >> s1;
          //cout << s1 << " ";
          if (s1 != "") {
            n++;
            sites(nsites).don(inst_num,n) = s1;
            sites(nsites).ndon(inst_num) = n;
          }
        };
        // cout << endl;
      } else if (s1 == "instlp") {
        //cout << i1 << " ";
        // Guard
        if (inst_num == 0) {cerr << "Instance number not found. Check if you have a inst statement before this line! " << endl;}
        int n = 0;
        while (line) {
          s1 = "";
          line >> s1;
          //cout << s1 << " ";
          if (s1 != "") {
            n++;
            sites(nsites).lp(inst_num,n) = s1;
            sites(nsites).nlp(inst_num) = n;
          }
        };
        //cout << endl;
      } else if (s1 == "site") {
        break;
      };
    }
    sites(nsites).max_nprot = max_nprot;
    sites(nsites).min_nprot = min_nprot;
    sites(nsites).max_nel = max_nel;
  }
  ninst.init_arr(1,titsites);
  for (int i=1; i<=titsites; i++) {
    if (sites(i).max_nprot > max_n_prot) {max_n_prot = sites(i).max_nprot;}
    if (sites(i).max_nel > max_n_el) {max_n_el = sites(i).max_nel;}
    ninst(i) = sites(i).ninst;
  };
}
int  siterep_site::find_inst_num(string &st) {
  int last = 0;
  for (int i=1; i<=ninst; i++) {
    if (st == labels(i)) {return i;}
    if (labels(i) != "") {last = i;}
  };
  labels(last+1) = st;
  return last+1;
}

void siterep_site::set_site(int nin, int max_natoms) {
  prot.init_arr(1,nin);
  el.init_arr(1,nin);
  atoms.init_arr(1,max_natoms);
  atom_change.init_arr(1,nin,1,max_natoms);
  don.init_arr(1,nin,1,max_natoms);
  acc.init_arr(1,nin,1,max_natoms);
  lp.init_arr(1,nin,1,max_natoms);
  heavy.init_arr(1,max_natoms);
  nlp.init_arr(1,nin);
  nacc.init_arr(1,nin);
  ndon.init_arr(1,nin);
  labels.init_arr(1,nin,"");
  ninst = nin;
  nheavy = 0;
  for (int s = 1; s<=nin; s++) {
    ndon(s) = 0;
    nacc(s) = 0;
    nlp(s) = 0;
    prot(s) = 0;
  };
}
ostream &operator<< (ostream &out,siterep &sr) {
  for (int i=1; i<=sr.titsites; i++) {
    out << "name " << sr.sites(i).name << endl;
    out << "ninst " << sr.sites(i).ninst << endl;
    out << "max_nprot " << sr.sites(i).max_nprot << endl;
    out << "min_nprot " << sr.sites(i).min_nprot << endl;
    out << "nheavy " << sr.sites(i).nheavy << endl;
    for (int j=1; j<=sr.sites(i).ninst; j++) {
      out << "inst " << j << endl;
      out << "nacc " << sr.sites(i).nacc(j) << endl;
      for (int k=1; k <= sr.sites(i).nacc(j); k++) {
        out << "acceptor " << sr.sites(i).acc(j,k) << endl;
      }
      out << "ndon " << sr.sites(i).ndon(j) << endl;
      for (int k=1; k<=sr.sites(i).ndon(j); k++) {
        out << "donor " << sr.sites(i).don(j,k) << endl;
      }
      out << "nlp " << sr.sites(i).nlp(j) << endl;
      for (int k=1; k<=sr.sites(i).nlp(j); k++) {
        out << "lone pair " << sr.sites(i).lp(j,k) << endl;
      }
      out << "prot" << sr.sites(i).prot(j) << endl;
    };
    cout << endl;
  };







  return out;
}

siterep::siterep(ifstream &file, int t) :titsites(0), max_n_prot(0), max_n_el(0) {
  if (!file) {cerr << "can't read siterep file";}
  int nsites = 0, nat = 0, max_nat = 0, i, tmp_n, max_nprot, min_nprot;
  int flag = 0, label, site_flag, local_n;
  string local_name, s1, s2, s3, s4, line, tmp, buff;
  while (file) {
    getline(file, buff, '\n');
    if ((signed int) buff.find("site") != -1) {
      nsites++;
    };
    if ((signed int) buff.find("instdon") != -1 || (signed int) buff.find("instacc") != -1 || (signed int) buff.find("instlp") != -1) {
      while ((signed int) buff.find(" ") != -1) {
        i = buff.find(" ");
        nat++;
        buff.assign(buff, i+2,buff.size());
      };
    };
    if (max_nat < nat) { max_nat = nat;}
  };
  cout << max_nat << " " << nsites << endl;
  sites.init_arr(1,nsites);
  file.clear();
  file.seekg(0, ios::beg);
  titsites = nsites;
  nsites = 0;
  max_nprot = 0;
  min_nprot = 100;
  while (file) {
    if (flag == 0) {file >> s1;}
    if (s1 == "site") {
      nsites++;
      flag = 0;
      site_flag = 1;
      file >> s2;
      local_name = s2;
      sites(nsites).name = s2;
      while (flag == 0 && file) {
        file >> s1;
        if (s1 == "ninst") {
          file >> s2;
          int tmp = atoi(s2.c_str());
          sites(nsites).prot.init_arr(1,tmp);
          sites(nsites).don.init_arr(1,tmp,1,max_nat);
          sites(nsites).acc.init_arr(1,tmp,1,max_nat);
          sites(nsites).lp.init_arr(1,tmp,1,max_nat);
          sites(nsites).heavy.init_arr(1,max_nat);
          sites(nsites).nlp.init_arr(1,tmp);
          sites(nsites).nacc.init_arr(1,tmp);
          sites(nsites).ndon.init_arr(1,tmp);
          sites(nsites).ninst = tmp;
          sites(nsites).nheavy = 0;
          for (int s = 1; s<=tmp; s++) {
            sites(nsites).ndon(s) = 0;
            sites(nsites).nacc(s) = 0;
            sites(nsites).nlp(s) = 0;
            sites(nsites).prot(s) = 0;
          };
        } else if (s1 == "heavy") {
          file >> s2;
          sites(nsites).nheavy = sites(nsites).nheavy + 1;
          sites(nsites).heavy(sites(nsites).nheavy) = s2;
        } else if (s1 == "inst") {
          file >> s2 >> s3 >> s4;
          sites(nsites).prot(atoi(s2.c_str())) = atoi(s3.c_str());
          if (atoi(s3.c_str()) >= max_nprot) {max_nprot = atoi(s3.c_str());}
          if (atoi(s3.c_str()) <= min_nprot) {min_nprot = atoi(s3.c_str());}
        } else if (s1 == "instacc" && site_flag) {
          local_n = 1;
          file >> s2;
          tmp_n = atoi(s2.c_str());
          if (tmp_n > sites(nsites).ninst || tmp_n == 0) {
            cerr << "instacc number larger than ninst in siterep or number missing for " << sites(nsites).name << endl;
            exit(0);
          };
          getline(file,line);
          label = 1;
          while (label) {
            read_col(line, tmp);
            sites(nsites).acc(tmp_n,local_n) = tmp;
            sites(nsites).nacc(tmp_n) = local_n;
            label = cut_string_begin(line);
            local_n++;
          };
        } else if (s1 == "instdon" && site_flag) {
          local_n = 1;
          file >> s2;
          tmp_n = atoi(s2.c_str());
          if (tmp_n > sites(nsites).ninst || tmp_n == 0) {
            cerr << "instdon number larger than ninst in siterep or number missing for " << sites(nsites).name << endl;
            exit(0);
          };
          getline(file,line);
          label = 1;
          while (label) {
            read_col(line, tmp);
            sites(nsites).don(tmp_n,local_n) = tmp;
            sites(nsites).ndon(tmp_n) = local_n;
            label = cut_string_begin(line);
            local_n++;

          };
        } else if (s1 == "instlp" && site_flag) {
          local_n = 1;
          file >> s2;
          tmp_n = atoi(s2.c_str());
          if (tmp_n > sites(nsites).ninst || tmp_n == 0) {
            cerr << "instlp number larger than ninst in siterep or number missing for " << sites(nsites).name << endl;
            exit(0);
          };
          getline(file,line);
          label = 1;
          while (label) {
            read_col(line, tmp);
            sites(nsites).lp(tmp_n,local_n) = tmp;
            sites(nsites).nlp(tmp_n) = local_n;
            label = cut_string_begin(line);
            local_n++;
          };
        } else if (s1 == "site") {
          flag = 1;
          sites(nsites).max_nprot = max_nprot;
          sites(nsites).min_nprot = min_nprot;
          max_nprot = 0;
          min_nprot = 100;
        } else {
          cerr << "Unknown word in siterep: " << s1 << endl;
          exit(0);
        };
      };
    };
  };
  sites(nsites).max_nprot = max_nprot;
  sites(nsites).min_nprot = min_nprot;

  ninst.init_arr(1,titsites);
  for (int i=1; i<=titsites; i++) {
    if (sites(i).max_nprot > max_n_prot) {max_n_prot = sites(i).max_nprot;}
    if (sites(i).max_nel > max_n_el) {max_n_el = sites(i).max_nel;}
    ninst(i) = sites(i).ninst;
  };
}


vis::vis(char *filename, residue& res) {
  ninst = res.ninst;
  natoms = res.natoms;

  ifstream file(filename);
  string s1, s2;
  names.init_arr(1,natoms,0,10);
  visible.init_arr(1,natoms,1,ninst);
  for (int i=1; i<=ninst+1; i++) {
    file >> s1; //skip first line
  };

  for (int i=1; i<=natoms; i++) {
    file >> s1 >> s2;
    if (s1 != res.name) {
      cerr << "Something is wron in vis file. Maybe wrong number of inst" << endl;
    };
    strcpy(names(i), s2.c_str());
    for (int j=1; j<=ninst; j++) {   //ninst + resname + Atomname
      file >> s1;
      visible(i,j) = atoi(s1.c_str());
    };
  };
}

atom_file::atom_file(string filename) {
  ifstream pqr(filename.c_str());
  if (!pqr) {cerr << "Could not open " << filename << endl;}
  string st1, atom, resn;
  int atomnum, resnum, nat;
  float x,y,z, rad, charge;
  stringstream line;
  nat = 0;
  while (my_get_line(line,pqr)) {
    line >> st1;
    if (st1 == "ATOM") {
      nat++;
    };
  };
  atoms.init_arr(1,nat);
  pqr.clear();
  pqr.seekg(0,ios::beg);
  pqr.clear();
  nat = 0;
  while (my_get_line(line,pqr)) {
    line >> st1;
    if (st1 == "ATOM") {
      x = y = z = rad = charge = 0;
      nat++;
      line >> atomnum >> atom >> resn >> resnum >> x >> y >> z >> charge >> rad;
      atoms(nat).set_atom(atomnum, 0, rad, charge, x, y, z, atom, resn, resnum);
    }
  }
  natoms = nat;
}

ostream& operator<< (ostream &out, atom &at) {
  //fprintf(Surfout,"ATOM%7d%4s%6s%6d%10.3f%8.3f%8.3f\n", h, "DUM", "DUM", 1,
  //      dotsurf.dots[i][1],dotsurf.dots[i][2],dotsurf.dots[i][3]);
  out << "ATOM";
  out << setw(7) << at.number;
  out << setw(5) << at.name;
  out << setw(5) << at.resname;
  out << setw(6) << at.resnum;
  out << setw(10) << fixed << setprecision(3) << at.x;
  out << setw(8)  << fixed << setprecision(3) << at.y;
  out << setw(8)  << fixed << setprecision(3) << at.z;
  out << setw(8)  << fixed << setprecision(3) << at.charge;
  out << setw(8)  << fixed << setprecision(3) << at.radius;
  out << endl;
  return out;
}

int number_of_lines(ifstream &file) {
  int count = 0;
  char tmp[100];
  while (file.getline(tmp,100)) {
    count++;
  };
  return count;
}

vis::~vis() {}

int cut_string_begin(string &st) {
  int label;
  while (st.find(" ") == 0) {
    label = st.find(" ");
    st.assign(st,label+1,st.size());
  };
  label = st.find(" ");
  st.assign(st,label+1,st.size());
  if (label == -1) {return 0;}
  else{return 1;};
}

int read_col(const string &st, string &out) {
  int label;
  string tmp;
  out = st;
  while (out.find(" ") == 0) {
    label = out.find(" ");
    out.assign(out,label+1,out.size());
  };
  label = out.find(" ");
  if (label != -1) {out.assign(out,0,label);};


  return 1;

}

double calc_err(vec<int> &val, int n) {
  double average, sum, er;
  average = sum = er = 0;
  for (int i =1; i<=n;i++) {
    average = average + val(i);
  };
  average = average/n;
  for (int i =1; i<=n;i++) {
    sum = sum + ((val(i) - average) * (val(i) - average));
  };
  er = sqrt(sum/n);
  return er;
}

double calc_err(vec<double> &val, int n) {
  double average, sum, er;
  average = sum = er = 0;
  for (int i =1; i<=n;i++) {
    average = average + val(i);
  };
  average = average/n;
  for (int i =1; i<=n;i++) {
    sum = sum + ((val(i) - average) * (val(i) - average));
  };
  er = sqrt(sum/n);
  return er;
}

void write_line_pdb(ostream &out, string atom, int atomnum, string atomlabel, string reslabel, int resid, double x, double y, double z, double beta, double occup) {
  out << setw(6) << left << atom;
  out << setw(5) << right << atomnum;
  out << setw(5) << atomlabel;
  out << setw(4) << reslabel;
  out << setw(6) << resid;
  out << setw(12) << fixed << setprecision(3) << x;
  out << setw(8) << fixed << setprecision(3) << y;
  out << setw(8) << fixed << setprecision(3) << z;
  out << setw(6) << fixed << setprecision(2) << beta;
  out << setw(6) << fixed << setprecision(2) << occup;
  out << endl;
}

void write_line_pqr(ostream &out, string atom, int atomnum, string atomlabel, string reslabel, int resid, double x, double y, double z, double charge, double radius) {
  out << setw(6) << left << atom;
  out << setw(5) << right << atomnum;
  out << setw(5) << atomlabel;
  out << setw(4) << reslabel;
  out << setw(6) << resid;
  out << setw(12) << fixed << setprecision(3) << x;
  out << setw(8) << fixed << setprecision(3) << y;
  out << setw(8) << fixed << setprecision(3) << z;
  out << setw(6) << fixed << setprecision(2) << charge;
  out << setw(6) << fixed << setprecision(2) << radius;
  out << endl;
}

