//
// C++ Implementation: graph_search_simple
//
// Description:
//
//
// Author: Mirco Till <Mirco.Till@uni-bayreuth.de>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "graph_search_simple.h"

graph_search_simple::graph_search_simple(){}

graph_search_simple::graph_search_simple(matrix<int> con, vec<int> vis):connections(con), visited(vis),ngraphs(0) {

}

void graph_search_simple::set_matrices(matrix<int> con, vec<int> vis){
    connections.init_arr(con);
    visited.init_arr(vis);
}


int graph_search_simple::search(){
    graph *iter;
    list_arg *iter2;
    if(ngraphs==0){
        ngraphs = graph_search(connections,visited);
    }
    // get number of graphs
    for(int i=1; i<=visited.get_dim(); i++){
        iter = graphs.search(visited(i));
        if(iter == NULL){iter = graphs.add(); iter->n = visited(i);}
        iter2 = iter->elements.add();
        iter2->n = i;
    }
    return ngraphs;
}

graph_search_simple::~graph_search_simple() {}


int graph_search ( matrix<int> &con, vec<int> &vis ) {
	int n = con.get_dim1();
	vis.kill_arr();
	vis.init_arr ( 1,n,0 );
	double_LL<list_arg> li;
	list_arg *cur;
	int ngraph = 0;
	for ( int i=1; i<= n; i++ ) {
		if ( vis ( i ) == 0 ) {
			li.add();
			li.tail->n = i;
			ngraph++;
			int nelements = 0;
			while ( li.head != NULL ) {
				cur = li.get_last();
				vis ( cur->n ) = ngraph;
				for ( int j=1; j<=n;j++ ) {
					if ( vis ( j ) == 0 && con ( cur->n,j ) ) {
						li.add();
						vis ( j ) = ngraph;
						li.tail->n = j;
					};
				};
				nelements++;
				delete cur;
			};
		};
	};
	return ngraph;
}

bool operator==(const int l1, const graph &l2){
        return l1 == l2.n;
}
bool operator==(const graph &l2, const int l1){
        return l1 == l2.n;
}
ostream & operator<<(ostream &out, const graph_search_simple &g){
   graph *g_iter;
   list_arg *e_iter;
   g_iter = g.graphs.head;
   while(g_iter != NULL){
       e_iter = g_iter->elements.head;
       while(e_iter != NULL){
           out << e_iter->n << endl;
           e_iter = e_iter ->next;
       };
       g_iter = g_iter->next;
   };
    return out;
}
