//
// C++ Interface: graph_search_simple
//
// Description:
//
//
// Author: Mirco Till <Mirco.Till@uni-bayreuth.de>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef GRAPH_SEARCH_SIMPLE_H
#define GRAPH_SEARCH_SIMPLE_H
#include "util.h"
/**Graph search
    Building a connectivity matrix from some input formats and stores the result of the graph search in a linked list.
	@author Mirco Till <Mirco.Till@uni-bayreuth.de>
*/


class graph{
    public:
    single_LL<list_arg> elements;
    graph *next;
    int n;
    graph(){};
    friend bool operator==(const int l1, const graph &l2);
    friend bool operator==(const graph &l2, const int l1);
};

class graph_search_simple {
        matrix<int> connections;
        vec<int> visited;
        single_LL<graph> graphs;
        int ngraphs;
	public:
            graph_search_simple();
            graph_search_simple(matrix<int> con, vec<int> vis);
            int search();
            void print_results();
            void set_matrices(matrix<int> con, vec<int> vis);
            ~graph_search_simple();
            friend ostream & operator<<(ostream &out, const graph_search_simple &g);

};

int graph_search ( matrix<int> &con,  vec<int> &vis );
#endif
