//
// C++ Implementation: histo
//
// Description:
//
//
// Author: Mirco Till <Mirco.Till@uni-bayreuth.de>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "histo.h"




histogram::histogram(double start_step, double start, double stop):step(start_step), min(start), max(stop), nsteps(1) {
  nsteps = (int)ceil((ceil(max-min)/step));
  elements.init_arr(1,nsteps);
  for (int i=1; i<=nsteps; i++) {
    elements(i).set_range(min+(i-1)*step,min+i*step);
  };
}

void histogram::add_element(double value) {
  int i;
  i=1;
  while (value > elements(i).range_stop) {
    i++;
  };
  elements(i).inc_count();
  /*
  for(i=1; i<= nsteps; i++){
      if(value > elements(i).range_start && value < elements(i).range_stop){
          elements(i).inc_count();
          break;
      };
  };
  */
}

ostream& operator<<(ostream &output, histogram &histo) {
  for (int i=1; i<=histo.nsteps; i++) {
    output << histo.elements(i).get_midpoint() << " " << histo.elements(i).get_count() << endl;
  };
  return output;
}
