//
// C++ Interface: histo
//
// Description: 
//
//
// Author: Mirco Till <Mirco.Till@uni-bayreuth.de>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef HISTO_
#define HISTO_
#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include <math.h>
#include "util.h"



class histogram_element{
    public: 
        double range_start;
    double range_stop;
    int count;
    histogram_element():range_start(0), range_stop(0), count(0){};
        void set_range(double start, double stop){range_start = start; range_stop = stop;};
        int inc_count(){return ++count; };
        inline int is_in_range(double val){if(val > range_start && val < range_stop){return 1;}else{ return 0;}};
        double get_midpoint(){return ((range_start + range_stop)/2);};
        int get_count(){return count;};
        double get_range_start(){return range_start;}
        double get_range_stop(){return range_stop;}
};

class histogram{
    private:
        vec<histogram_element> elements;
        double step, min, max;
        int nsteps;
    public:
        histogram(double start_step, double start, double stop);
        void add_element(double value);
        friend ostream& operator<<(ostream &output, histogram &histo);
    
    
    
    
    
    
    
    
    
    
    
    
    
};
















#endif
