#include <iostream>
#include <ctime>
#include "math.h"
#include <vector>
#include "util.h"
using namespace std;

int main(){
  cout << "Size of char: " << sizeof(char) << " holding " << pow(2,sizeof(char)*8) <<  endl;
  cout << "Size of short int: " << sizeof(short int) << " holding " << pow(2,sizeof(short int)*8) <<  endl;
  cout << "Size of int: " << sizeof(int) <<" holding " << pow(2,sizeof(int)*8) << endl;
  cout << "Size of float: " << sizeof(float) << " holding " << pow(2,sizeof(float)*8) <<endl;
  cout << "Size of double: " << sizeof(double) << " holding " << pow(2,sizeof(double)*8) <<endl;
  cout << "Size of long double: " << sizeof(long double) << " holding " << pow(2,sizeof(long double)*8) <<endl;
  cout << "Size of char pointer: " << sizeof(char*)  <<  endl;
  cout << "Size of C++ vector<double>: " << sizeof(vector<double>) << endl;
  cout << "Size of my vector<double>: " << sizeof(vec<double>) << endl;
  cout << "Size of my matrix<double>: " << sizeof(matrix<double>) << endl;
  cout << "Size of my tensor<double>: " << sizeof(tensor<double>) << endl;
  cout << "Size of my 4d_tensor<double>: " << sizeof(d4_tensor<double>) << endl;
  
  
  cout << "---------------------------------------" << endl;
  cout << "Speed calculations with clock per second: " << CLOCKS_PER_SEC << endl;
  int i,k, arr[10000], arr2[10000], arr3[10000];
  vec<double> tmp_int_vec(1,10,5);
  tensor<double> tmp_double_vec(1,10,1,10,5,10,1);
  double tmp_double_arr[10][10][10];
  const double border = 1E9;
  double k1, k2, k3;
  clock_t start_clock, stop_clock, loop_clock;
  start_clock = clock();
  for(i=1;i<=border;i++){
  };
  stop_clock = clock();
  cout << "Loop with 1E9 steps: " << stop_clock - start_clock << endl;
  loop_clock = stop_clock - start_clock;
  cout << "This time will be substracted from all further calcs!" << endl;
  for(int i=1;i<10;i++){
      for(int j=1;j<10;j++){
          for(int k=1;k<10;k++){
              tmp_double_arr[i][j][k] = 1;
          };
      };
  };
  
  k=0;
  k1 = 5;
  k2 = 6;
  k3 = 5.5; 
  // assigning
  start_clock = clock();
  for(i=1;i<=border;i++){
      k = 5;
  };
  stop_clock = clock();
  cout << "k = 5: " << (double)((stop_clock - start_clock) - loop_clock)/CLOCKS_PER_SEC << endl;
  // increment operator;
  start_clock = clock();
  for(i=1;i<=border;i++){
      k++;
  };
  stop_clock = clock();
  cout << "k++: " << (double)((stop_clock - start_clock) - loop_clock)/CLOCKS_PER_SEC << endl;
  // addition
  k=0;
  start_clock = clock();
  for(i=1;i<=border;i++){
      k = k+5;
  };
  stop_clock = clock();
  cout << "k= k+5: " << (double)((stop_clock - start_clock) - loop_clock)/CLOCKS_PER_SEC << endl;
  // multiplication
  k=2;
  start_clock = clock();
  for(i=1;i<=border;i++){
      k = k*2;
  };
  stop_clock = clock();
  cout << "k= k*5: " << (double)((stop_clock - start_clock) - loop_clock)/CLOCKS_PER_SEC << endl;
  // integer division
  start_clock = clock();
  for(i=1;i<=border;i++){
      k1 = k1/k2;
  };
  stop_clock = clock();
  cout << "k1= k1/k2: " << (double)((stop_clock - start_clock) - loop_clock)/CLOCKS_PER_SEC << endl;
  // pointer arithmetik
  start_clock = clock();
  for(i=1;i<=border;i++){
      arr[k] = k;
  };
  stop_clock = clock();
  cout << "arr[k] = k: " << (double)((stop_clock - start_clock) - loop_clock)/CLOCKS_PER_SEC << endl;
  // pointer arithmetik
  arr3[k] = k;
  arr2[arr3[k]] = k;
  start_clock = clock();
  for(i=1;i<=border;i++){
      arr[arr2[arr3[k]]] = k;
  };
  stop_clock = clock();
  cout << "arr[arr2[arr3[k]]] = k: " << (double)((stop_clock - start_clock) - loop_clock)/CLOCKS_PER_SEC << endl;
  // rounding
  start_clock = clock();
  for(i=1;i<=border;i++){
      k = (int)(i+0.5);
  };
  stop_clock = clock();
  cout << "k = (int)(i+0.5): " << (double)((stop_clock - start_clock) - loop_clock)/CLOCKS_PER_SEC << endl;
  // ceil
  start_clock = clock();
  for(i=1;i<=border;i++){
      k = (int) ceil(i+0.5);
  };
  stop_clock = clock();
  cout << "k = ceil(i+0.5): " << (double)((stop_clock - start_clock) - loop_clock)/CLOCKS_PER_SEC << endl;
  // exp
  /*
  start_clock = clock();
  for(i=1;i<=border;i++){
      k1 = exp(i+0.5);
  };
  stop_clock = clock();
  cout << "k = exp(i+0.5): " << (double)((stop_clock - start_clock) - loop_clock)/CLOCKS_PER_SEC << endl;
  // if
  */
  k=1;
  start_clock = clock();
  for(i=1;i<=border;i++){
      if(i<border){k++;};
  };
  stop_clock = clock();
  cout << "if(i<border){k++}: " << (double)((stop_clock - start_clock) - loop_clock)/CLOCKS_PER_SEC << endl;
  // new/delete
  k=1;
  start_clock = clock();
  for(i=1;i<=border;i++){
      delete [] new int[10];
  };
  stop_clock = clock();
  cout << "delete [] new int[10]: " << (double)((stop_clock - start_clock) - loop_clock)/CLOCKS_PER_SEC << endl;
  
  start_clock = clock();
  for(i=1;i<=border;i++){
      tmp_int_vec.arr[1] = 5;
  };
  stop_clock = clock();
  cout << "vec(): " << (double)((stop_clock - start_clock) - loop_clock)/CLOCKS_PER_SEC << endl;
  
  start_clock = clock();
  for(i=1;i<=border;i++){
      tmp_double_vec.arr[1][1][1] = 5;
  };
  stop_clock = clock();
  cout << "tensor(): " << (double)((stop_clock - start_clock) - loop_clock)/CLOCKS_PER_SEC << endl;
  
  start_clock = clock();
  for(i=1;i<=border;i++){
      tmp_double_arr[1][1][1] = 5;
  };
  stop_clock = clock();
  cout << "arr[][][]: " << (double)((stop_clock - start_clock) - loop_clock)/CLOCKS_PER_SEC << endl;
}

