#ifndef TENSOR_
#define TENSOR_
#include <iostream>
#include <iomanip>
#include "matrix.h"

template<class T>
class tensor{
    private:
        int dim1, dim2, dim3;
        int start1, start2, start3;
        float space;
        int *spare;
        matrix<int> spare_mat;
    public:
        T ***arr;
        tensor(): dim1(0), dim2(0), dim3(0), start1(0), start2(0), start3(0), space(sizeof(tensor)), spare(NULL), arr(NULL){
        };
        tensor(int x, int x2, int y, int y2, int z, int z2): dim1(0), dim2(0), dim3(0), start1(0), start2(0), start3(0), space(sizeof(tensor)), spare(NULL), arr(NULL){
            init_arr(x,x2,y,y2,z,z2);
        }
        tensor(int x, int x2, int y, int y2, int z, int z2, T ini): dim1(0), dim2(0), dim3(0), start1(0), start2(0), start3(0), space(sizeof(tensor)), spare(NULL), arr(NULL){
            init_arr(x,x2,y,y2,z,z2,ini);
        }
        tensor(int x, int x2, T ini, int *sizes1, matrix<int> &sizes2): dim1(0), dim2(0), dim3(0), start1(0), start2(0), start3(0), space(sizeof(tensor)), spare(NULL), arr(NULL){
             init_arr(x,x2,sizes1,sizes2,ini);
        }
        void init_arr(int x, int x2, int y, int y2, int z, int z2){
            dim1 = x2 - x +1;
            dim2 = y2 - y +1;
            dim3 = z2 - z +1;
            start1 = x;
            start2 = y;
            start3 = z;
            try{
                arr = new T**[dim1];
                space += dim1 * sizeof(T**);
                arr = arr - start1;
                arr[x] = new T*[dim1*dim2+1];
                space += (dim1 * dim2 +1) * sizeof(T*);
                arr[x] -= start2;
                arr[x][y] = new T[dim1*dim2*dim3+1];
                space += (dim1 * dim2 *dim3 +1) * sizeof(T);
                arr[x][y] -= start3;
                // Since we dont run over all elemetns in the first dimension...
                for(int i=y+1; i<=y2; i++){arr[x][i] = arr[x][i-1]+dim3;}
                // Set the rest
                for(int i=x+1; i<=x2; i++){
                    arr[i] = arr[i-1] + dim2;
                    arr[i][y] = arr[i-1][y] + dim2*dim3;
                    for(int j=y+1;j<=y2;j++){
                        arr[i][j] = arr[i][j-1]+dim3;
                    };
                };
            }catch(bad_alloc){
                cerr << "To less memory for tesor!" << endl;
                cerr << "dimensions: " << dim1 << " " << dim2 << " " << dim3 << endl;
                exit(0);
            };

        };
        void init_arr(int x, int x2, int y, int y2, int z, int z2, T ini){
            init_arr(x,x2,y,y2,z,z2);
            for(int i=x; i<=x2; i++){
                for(int j=y; j<=y2;j++){
                    for(int k=z; k<=z2; k++){
                        arr[i][j][k] = ini;
                    };
                };
            };
        }
        void init_arr(int x, int x2, int *sizes1, matrix<int> &sizes2){
            vec<int> tmp_vec(x,x2);
            for(int i=x; i<=x2; i++){
                tmp_vec(i) = sizes1[i];
            };
            init_arr(x,x2,tmp_vec,sizes2);
        };
        void init_arr(int x, int x2, vec<int> &sizes1, matrix<int> &sizes2){
            if(spare == NULL){
                spare = new int[x2-x + 2];
                space += sizeof(int)*(x2-x+2);
                spare_mat.init_arr(x,x2,sizes1,0);
                space += spare_mat.get_space();
                for(int i=x; i<= x2; i++){
                    spare[i] = sizes1(i);
                    for(int j=1; j<= sizes1(i); j++){
                        spare_mat(i,j) = sizes2(i,j);
                    }
                }
            }
            dim1 = x2 - x +1;
            dim2 = 0;
            dim3 = 0;
            start1 = x;
            start2 = 1;
            start3 = 1;
            try{
                arr = new T**[dim1];
                arr = arr - start1;
                space += sizeof(T**)*dim1;
                for (int i=start1;i<=dim1;++i){
                    arr[i] = new T*[sizes1(i)];
                    arr[i] = arr[i] - start2;
                    space += sizeof(T*)*sizes1(i);
                }
                for (int i=start1;i<=dim1;i++){
                    for (int j=start2;j<=sizes1(i);++j){
                        arr[i][j] = new T[sizes2(i,j)];
                        arr[i][j] = arr[i][j] - start3;
                        space += sizeof(T)*sizes2(i,j);
                    }
                }
            }catch(bad_alloc){
                cerr << "To less memory for tesor!" << endl;
                for (int i=start1;i<=dim1;i++){
                    for (int j=start2;j<=sizes1(i);++j){
                        cerr << "dimensions2: " << sizes2(i,j) << " " << endl;
                    };
                };
                exit(0);
            };
        };
        void init_arr(int x, int x2, vec<int> &sizes1, matrix<int> &sizes2, T ini){
            init_arr(x,x2,sizes1,sizes2);
           for(int i=x; i<=x2;i++){
               for(int j=1; j<=sizes1(i);j++){
                   for(int k=1; k<=sizes2(i,j);k++){
                       arr[i][j][k] = ini;
                   };
               };
           };

        }
        int get_dim1(){return dim1;}
        int get_dim2(){return dim2;}
        int get_dim3(){return dim3;}
        int get_dim2(int x){return spare[x];}
        int get_dim3(int x, int y){return spare_mat(x,y);}
        double get_space(){return space;};
        int is_inside(int i, int i2, int s, int up_to = -1){
          if(up_to == -1 || up_to > dim3 +start3 - 1){
            up_to = dim3 +start3 - 1;
          };
          if(dim3 > 0){
            for(int j=1; j<=up_to; j++){
              if(arr[i][i2][j] == s){return 1;};
            };
          };
          return 0;
        }
        void kill_arr(){
            if(spare == NULL){
                if(arr != NULL){
                arr[start1][start2] += start3;
                delete [] arr[start1][start2];
                arr[start1] += start2;
                delete [] arr[start1];
                arr += start1;
                delete [] arr;
                };
            }else{
            for (int i=start1;i<=start1 + dim1-1;i++){
                    for (int j=start2;j<=spare[i];++j){
                        arr[i][j] = arr[i][j] + start3;
                        delete [] arr[i][j];
                    }
                }

            for (int i=start1;i<=start1 + dim1-1;++i){
                arr[i] = arr[i] + start2;
                delete [] arr[i];
            };
            arr = arr + start1;
            delete [] arr;
            }
            arr = NULL;
            dim1 = dim2 = dim3 = start1 = start2 = start3 = 0;
        };
        ~tensor(){
            if(arr){
                kill_arr();
            };
            delete [] spare;
        };
        T &operator()(int x, int y, int z){
            return arr[x][y][z];
        };
        T *operator()(int x, int y){
            return arr[x][y];
        }
};

#endif
