#ifndef UTILS_
#define UTILS_
#include <iostream>
#include "gzstream.h"
#include "vector.h"
#include "matrix.h"
#include "sparse_matrix.h"
#include "tensor.h"
#include "4d_tensor.h"
#include "file_io.h"
#include "mempool.h"
#include "timer.h"
#include "energy_calcs.h"
#include "histo.h"
#include "qmpb_energies.h"
#include "error_calcs.h"
#include "vector_calcs.h"
#include "constants.h"
#include "lists.h"
#include "graph_search_simple.h"
#include "pq.h"
#include "math_things.h"
#include "adv_doubly_ll.h"
#include "sites.h"
/*! \mainpage
 *
 * \section intro_sec Introduction
 *
 * Library of supporting routines for memory allocation and energy calculations
 *
 *
  Example usage For the storage classes (vec, matrix, tensor, d4_tensor):<br>
  <h2>Dense Matrix:</h2>
  <code>
  matrix<int> example1;<br>
  example1.init_arr(1,100,1,100);<br>
  for(int i=1; i<=100;i++){<br>
  &nbsp;&nbsp;for(int j=1; j<=100;j++){<br>
  &nbsp;&nbsp;&nbsp;&nbsp;example1(i,j) = 0;<br>
  &nbsp;&nbsp;}<br>
  }<br>
  </code>
  <br>
  =<br>
  <br>
  <code>
  matrix<int> example2(1,100,1,100,0);<br>
  </code>
  <h2>Sparse Matrix:</h2>
  <code>
  vec<int> tmp(1,10,0);
  for(int i=1; i<=10;i++){<br>
  &nbsp;&nbsp;tmp(i) = i;<br>
  }<br>
  matrix<int> example3;<br>
  example3.init_arr(1,10,tmp,0);<br>
  <br>
  Results in the following matrix: <br>
  0<br>
  0 0<br>
  0 0 0 <br>
  0 0 0 0<br>
  0 0 0 0 0<br>
  ...<br>
 */

#endif //UTILS_
