//
// C++ Implementation: vector_calcs
//
// Description:
//
//
// Author: Mirco Till <Mirco.Till@uni-bayreuth.de>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include "vector_calcs.h"

float dot_p(double x1, double y1, double z1, double x2, double y2, double z2) {
  double tmp = 0;
  tmp += x1*x2;
  tmp += y1*y2;
  tmp += z1*z2;
  return tmp;
}

float dot_p(atom &at1, atom &at2) {
  double tmp = 0;
  tmp += at1.x * at2.x;
  tmp += at1.y * at2.y;
  tmp += at1.z * at2.z;
  return tmp;
}
float dot_p(vec<double> &v1, vec<double> &v2) {
  double tmp = 0;
  tmp += (v1(1) * v2(1));
  tmp += (v1(2) * v2(2));
  tmp += (v1(3) * v2(3));
  return tmp;
}
float length(vec<double> &v) {
  double tmp = 0;
  tmp += v(1)*v(1);
  tmp += v(2)*v(2);
  tmp += v(3)*v(3);
  return sqrt(tmp);
}

float angle(atom &at1, atom &at2, atom &at3) {
  vec<double> v1, v2;
  v1.init_arr(1,3);
  v2.init_arr(1,3);
  v1(1) = at1.x - at2.x;
  v1(2) = at1.y - at2.y;
  v1(3) = at1.z - at2.z;
  v2(1) = at3.x - at2.x;
  v2(2) = at3.y - at2.y;
  v2(3) = at3.z - at2.z;
  return angle(v1,v2);
}

float angle(vec<double> &v1, vec<double> &v2) {
  double tmp = 0;
  tmp = dot_p(v1,v2)/(length(v1)*length(v2));
  return acos(tmp) * (180/util_pi);
}

double get_dist(const atom &atom1, const atom &atom2) {
  double dist;
  dist = 0;
  dist = dist + (atom1.x - atom2.x) * (atom1.x - atom2.x);
  dist = dist + (atom1.y - atom2.y) * (atom1.y - atom2.y);
  dist = dist + (atom1.z - atom2.z) * (atom1.z - atom2.z);
  dist = sqrt(dist);
  return dist;
}

double get_dist(double p1x, double p1y, double p1z, double p2x, double p2y, double p2z) {
  double dist;
  dist = 0;
  dist = dist + (p1x - p2x) * (p1x - p2x);
  dist = dist + (p1y - p2y) * (p1y - p2y);
  dist = dist + (p1z - p2z) * (p1z - p2z);
  dist = sqrt(dist);
  return dist;
}
double get_sqr_dist(double p1x, double p1y, double p1z, double p2x, double p2y, double p2z) {
  double dist;
  dist = 0;
  dist = dist + (p1x - p2x) * (p1x - p2x);
  dist = dist + (p1y - p2y) * (p1y - p2y);
  dist = dist + (p1z - p2z) * (p1z - p2z);
  return dist;
}

