//
// C++ Interface: vector_calcs
//
// Description:
//
//
// Author: Mirco Till <Mirco.Till@uni-bayreuth.de>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef VECTOR_CALCS_
#define VECTOR_CALCS_
#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include <math.h>
#include "file_io.h"
#include "constants.h"

using namespace std;

float dot_p(double x1, double y1, double z1, double x2, double y2, double z2);
float dot_p(atom &at1, atom &at2);
float angle(vec<double> &v1, vec<double> &v2);
float angle(atom &at1, atom &at2, atom &at3);
float length(vec<double> &v);
double get_dist(const atom &atom1, const atom &atom2);
double get_dist(double p1x, double p1y, double p1z, double p2x, double p2y, double p2z);
double get_sqr_dist(double p1x, double p1y, double p1z, double p2x, double p2y, double p2z);
#endif
