
#ifndef _TESTVOLUME_
#define _TESTVOLUME_

#include <iostream>
#include <string>
#include <stdio.h>
#include <stdlib.h>
//#include <string.h>
#include <time.h>
#include <math.h>
#include "mathematik.h"
#include "random.h"
#include "mus_atom.h"
#include "util.h"
#include "util_c.h"
#include "nrutil.h"
#include "energy.h"
#include "grid.h"
#include "nb-list.h"
#include "surface.h"
#include "volume.h"
#include "cavity_search.h"
#include "cavity2.h"
#include "mit_surface.h"
#include "grid_helper.h"
#include "monte_carlo_run.h"
#include "sys.h"
#define PRTPT(NAME, PT) {/*PT[1]=10.0*PT[1];\
                         PT[2]=10.0*PT[2];\
                         PT[3]=10.0*PT[3];\
                         fprint_DUMMYatomPQR(stdout, i, NAME, PT, \
                         sqrt(SqrLength(PT)));*/\
                        }


using namespace std;
/*! \mainpage
 *
 * \section intro_sec Introduction
    This Program was written to find cavities inside proteins. It first calculates a dot surface, followed by a volume calculation of the protein.
    The volume calculation is done by a Monte Carlo algorithm. The protein is mapped to a %grid. Random points are chosen and also mapped to that %grid. Each %point is tested for beeing in a small void, inside an atom or in the solvent. A graph search algorithm groups all points marked as solvent. One big group is the real solvent, all other groups are located inside the protein and are supposed to be cavities. The same Monte Carlo algorithm is applied again, with a finer %grid. Additionally Surface clefts are searched by defining den amount of protein around each solvent %point. Water molecules are randomly placed in the cavities and relaxed to fill the whole cavity. If two cavities are located close to each other, artificial cavities can be created by the refinement algorithm. Therefore we test for overlapping cavities and merge them or delete them. <br>
    If membrane z dimensions are set (difference between min and max value bigger than 0.1 Angstrom), a membrane of dummy atoms is created from the "solvent cavity". This membrane is created as a slice between the min and max z values. the slice is as thick around the protein as given in MembDim and has therefore the same shape as the protein surface.
    \section man How to use
    To run this program, you need two files. A pqr file of your protein and a setupfile, defining the parameters. The following parameters can be set in the setup file:
    <ul>
      <li><b>nmc</b>&nbsp;&nbsp;&nbsp;Number of Monte Carlo steps per A^3 (Default 10)</li>
      <li><b>probe</b>&nbsp;&nbsp;&nbsp;Probesphere Radius</li>
      <li><b>surfPT</b>&nbsp;&nbsp;&nbsp;Number of surface points placed on each atom</li>
      <li><b>membZmin</b>&nbsp;&nbsp;&nbsp;Minimum z coordinate for the membrane</li>
      <li><b>membZmax</b>&nbsp;&nbsp;&nbsp;Maximum z coordinate for the membrane</li>
      <li><b>cavgridspacing</b>&nbsp;&nbsp;&nbsp; %Grid spacing for the cavity volume refinement</li>
      <li><b>startgridspacing</b>&nbsp;&nbsp;&nbsp; %Grid spacing for the initial volume calculation</li>
      <li><b>blab</b>&nbsp;&nbsp;&nbsp;Debug output level</li>
      <li><b>DummyRad</b>&nbsp;&nbsp;&nbsp;Radius of the dummy atoms placed</li>
      <li><b>MembDim</b>&nbsp;&nbsp;&nbsp;Thisckness of the membrane slice in y/z dimensions. Thickness between protein and solvent</li>
      <li><b>CoreZMin</b>&nbsp;&nbsp;&nbsp;Minimum zcoordinate of the membrane core region</li>
      <li><b>CoreZMax</b>&nbsp;&nbsp;&nbsp;Maximum z coordinate of the membrane core region</li>
      <li><b>CoreDim</b>&nbsp;&nbsp;&nbsp;Maximum distance a head group atom is allowed to be apart from the core region</li>
      <li><b>CleftDim</b>&nbsp;&nbsp;&nbsp;Dimesion of the cleft search box</li>
      <li><b>CleftRel</b>&nbsp;&nbsp;&nbsp;Percentage of the box neccessarily occupied by protein</li>
      <li><b>CleftMethod</b>&nbsp;&nbsp;&nbsp;Method for cleft serach</li>
      <li><b>DeleteOverlapping</b>&nbsp;&nbsp;&nbsp;Delete overlapping cavities instead of merging</li>
      <li><b>SurfaceCluster</b>&nbsp;&nbsp;&nbsp;Cluster surface dots</li>
      <li><b>minVol</b>&nbsp;&nbsp;&nbsp;Minimum volume of a cavity to be recorded</li>
      <li><b>waterVol</b>&nbsp;&nbsp;&nbsp;Volume of one water molecule (Default 18 Angstrom^3)</li>
    </ul>
    The setup file has the same name as the pqr file, but ".setup" instead of ".pqr". Running the program is now very simple: <br>
    <b>vol molname</b><br>
    Molname is the name of your protein. Your pqrfile is named "molname.pqr". Most of the output goes into a cav directory. There you will find the cavities, as well as the real clefts and the membrane.
*/

#endif
